#include "usart.h"
#include "string.h"
#include "ring_buffer.h"
#include "mqttRecv.h"
#include "main.h"
#include "parseDeviceMessage.h"

/*
 *  Receive_MQTT_DataPack(void)
 *  
 *  
 *  ֵ
 *  ãյmqttĵϢʱд뱣浽λ
 */
void Receive_MQTT_DataPack(void)
{
    if (strstr((const char *)UART0_RX_BUF, "QMTRECV") != NULL)
    {
			if(strstr((const char *)UART0_RX_BUF,"reboot"))
			{
				NVIC_SystemReset();//յ־
			}
        UART0_RX_MQTT_SUB_STAT = 1; // MQTTϢ־λ
        int i = 0;
        while (UART0_RX_BUF[i] != '{')
        {
            i++; // λjsonϢʼ
        }
        for (; i < strlen(UART0_RX_BUF); i++)
        {
            ring_buffer_write(UART0_RX_BUF[i], &mqttRecv);
            if (UART0_RX_BUF[i] == '}')
            {
                break;
            }
        }
        Clear_DMA_Buffer();
    }
		else if(strstr((const char *)UART0_RX_BUF, "QMTSTAT:")!=NULL)//ΪMQTT·仯
		{
			NVIC_SystemReset();//ʱ
		}
}
/*
 *  bool MQTT_BUFFER_READ(uint8_t* json)
 *  json --> ָĿ껺
 *  
 *  ֵtrueɹҵjsonϢ falseδҵjsonϢ
 *  ãӻλжjsonϢ
 */
bool MQTT_BUFFER_READ(uint8_t *json)
{
    static uint8_t json_len = 0;
    static uint8_t json_buf[128];
    uint8_t recv_data;
    bool found_json_end = false;
    bool json_start = false;
    while (ring_buffer_read(&recv_data, &mqttRecv) != -1)
    {
        if (recv_data == '{')
        {
            json_start = true;
            json_len = 0;
        }
        // ǰJSONΧ
        if (json_start)
        {
            json_buf[json_len++] = recv_data;
            // ҵJSONĽ
            if (recv_data == '}')
            {
                found_json_end = true;
                // JSON
                json_buf[json_len] = '\0';      // ַ
                strcpy(json, (char *)json_buf); // JSONݿ
                // JSON
                memset(json_buf, 0, sizeof(json_buf));
                json_len = 0;
                json_start = false;
            }
        }
        if (found_json_end)
        {
            break;
        }
    }

    return found_json_end;
}
