#include "otaEvent.h"
#include "usart.h"
#include "systick.h"
#include "w25q32.h"
#include "main.h"

#define APPBLOCKNB 2      	//صĳλblockĵ3
#define OTA_EVENT_BLOCKNB 1 //OTA¼ɱ־洢λλڵ2

#define SOH 0x01 // XMODЭ֡ͷ
#define ACK 0X06 // Ӧ־
#define NAK 0x15 // Ӧ־
#define EOT 0x04 // ־
int8_t xmodem(uint16_t timeout);
OTA_T ota_data;
uint8_t w25q32_data[256];  //w25q32

uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen);
/*
 *  uint8_t check_ota_event()
 *  
 *  
 *  ֵ
 *  ãжota¼ǷǷҪ²
 */
int8_t check_ota_event()
{
	                                           //رտŹ
	// ־λΪ1ʱ֤ota¼,ota·
	if (ota_data.ota_flag == 1)
	{
		W25Q32_Erase64K(APPBLOCKNB);                    //ļڵblockԺ
		int8_t recvSta = xmodem(1000);
		if (recvSta == 0)
		{
			return 0;
		}
		else  
		{
			NVIC_SystemReset();
		}
	}
	else
		return 0;
}

int8_t xmodem(uint16_t timeout)
{
	int startTime = gettick();
	ota_data.done=0;
	OTA_flag data_flag;
	data_flag.flag=0;
	data_flag.xmodemNB=0;                         
	while(1)
	{
		task_fwdgt_reload();                                 //ι
		if(gettick()-startTime>timeout*1000)return 0;
		usart_data_transmit(COM_232, 'C');
		delay_1ms(1000);
		if(ota_data.done==1)break;
	}
	// ж֡ͷǷϱ׼
	while (gettick() - startTime < timeout * 1000)
	{
		if (ota_data.done == 1)
		{
			task_fwdgt_reload();                                       //ι
			if (ota_data.data[0] == SOH && ota_data.data_cnt == 133)
			{
				uint16_t XCRC = Xmodem_CRC16(ota_data.data + 3, 128);
				if (XCRC == ota_data.data[131] * 256 + ota_data.data[132]) // Уһʱݴ
				{
					data_flag.xmodemNB++;
					//ΪW25Q32ְֻ֧ҳдݡԽ128ֽһݴռ䣬ӦŽһд룬ڽжǷΪڽ
					//βĴ
					if(ota_data.data[1]%2==0)                                      
					{
						memcpy(w25q32_data+128,ota_data.data + 3,128);
						W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
						memset(w25q32_data,0,256);
					}
					else
					{
						memcpy(w25q32_data,ota_data.data + 3,128);
					}
					
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, ACK);
	
				}
				else
				{
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, NAK);
				}
			}
			//İ
			else if (ota_data.data[0] == EOT && ota_data.data_cnt == 1)
			{
				if(data_flag.xmodemNB%2!=0)                                            //Ϊдȥ
				{
					W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
				}
				
				
				
				usart_data_transmit(COM_232, ACK);
				//xmodemЭĽɵı־洢ڴ
				OTA_MESSAGE ota_message;
				ota_message.Completion_flag=1U;
				ota_message.XmodemByte=data_flag.xmodemNB*128;//0x1AҪһ

				W25Q32_Erase64K(OTA_EVENT_BLOCKNB);//ԭȵ
				W25Q32_PageWrite((uint8_t *)&ota_message,OTA_EVENT_BLOCKNB*256);
			
				delay_1ms(50);
				// д¼ɱ־豸,״̬ҳعдɻִָ
				return 1;
			}
			else
			{
				ota_data.data_cnt = 0;
				memset(ota_data.data, 0, 133);
				ota_data.done = 0;
				usart_data_transmit(COM_232, NAK);
			}
		}

		delay_1ms(1);
	}
	return 0;
}

/*-------------------------------------------------*/
/*Xmodem_CRC16У                         */
/*  dataָ  datalenݳ        */
/*ֵУ                             */
/*-------------------------------------------------*/
uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen)
{

	uint8_t i;					// forѭ
	uint16_t Crcinit = 0x0000;	// Xmdoem CRCУĳʼֵ0x0000
	uint16_t Crcipoly = 0x1021; // Xmdoem CRCУĶʽ0x1021

	while (datalen--)
	{									  // datalenСжֽѭٴ
		Crcinit = (*data << 8) ^ Crcinit; // ȽУֽڣŲ8λ
		for (i = 0; i < 8; i++)
		{											 // ÿֽ8λѭ8
			if (Crcinit & 0x8000)					 // жBIT1510,1Ļif
				Crcinit = (Crcinit << 1) ^ Crcipoly; // 1Ļƣʽ
			else									 // жBIT1510,0Ļelse
				Crcinit = (Crcinit << 1);			 // 0Ļֻ
		}
		data++; // ƣһֽ
	}
	return Crcinit; // У
}
