#ifndef KEY_H
#define KEY_H

#include "stdint.h"

typedef enum 
{
    KEY_SYS_RECOVERY = 0,
} key_typedef_enum;

typedef enum 
{
    KEY_MODE_GPIO = 0,
    KEY_MODE_EXTI = 1
} keymode_typedef_enum;


#define KEYn                             1U

#define SYS_RECOVERY_KEY_PIN 								GPIO_PIN_1
#define SYS_RECOVERY_KEY_GPIO_PORT 					GPIOA
#define SYS_RECOVERY_KEY_GPIO_CLK           RCU_GPIOA
#define SYS_RECOVERY_KEY_EXTI_LINE          EXTI_1
#define SYS_RECOVERY_KEY_EXTI_PORT_SOURCE   GPIO_PORT_SOURCE_GPIOA
#define SYS_RECOVERY_KEY_EXTI_PIN_SOURCE    GPIO_PIN_SOURCE_1
#define SYS_RECOVERY_KEY_EXTI_IRQn   				EXTI1_IRQn 

void gd_eval_key_init(key_typedef_enum key_num, keymode_typedef_enum key_mode);

#endif


