
#ifndef __RING_BUFFER_H
#define __RING_BUFFER_H

#include "gd32f10x.h"

#define BUFFER_SIZE (4*1024)       /* λĴС */
typedef struct
{
    volatile unsigned int pW;           /* дַ */
    volatile unsigned int pR;           /* ַ */
    unsigned char buffer[BUFFER_SIZE];  /* ռ */
} ring_buffer;

/*
 *  void ring_buffer_init(ring_buffer *dst_buf)
 *  dst_buf --> ָĿ껺
 *  
 *  ֵ
 *  ãʼ
*/
extern void ring_buffer_init(ring_buffer *dst_buf);

/*
 *  void ring_buffer_write(unsigned char c, ring_buffer *dst_buf)
 *  c --> Ҫд
 *            dst_buf --> ָĿ껺
 *  
 *  ֵ
 *  ãĿ껺дһֽڵݣ˾Ͷ
*/
extern void ring_buffer_write(unsigned char c, ring_buffer *dst_buf);

/*
 *  int ring_buffer_read(unsigned char *c, ring_buffer *dst_buf)
 *  c --> ָ򽫶ݱ浽ڴеĵַ
 *            dst_buf --> ָĿ껺
 *  
 *  ֵݷ0򷵻-1
 *  ãĿ껺ȡһֽڵݣ˷-1ȡʧ
*/
extern int ring_buffer_read(unsigned char *c, ring_buffer *dst_buf);

#endif /* __RING_BUFFER_H */
