#ifndef OTAEVENT_H
#define OTAEVENT_H
#include <stdint.h>

typedef struct OTA_T
{
	uint8_t data[133]; // xmod协议长133
	uint16_t data_cnt;
	uint8_t done;
	uint8_t ota_flag; // ota标志位 0无ota事件发生 1 ota事件发生中  0xFE ota事件完成
} OTA_T;

typedef struct OTA_FLAG
{
	uint8_t flag;								//存储的flag  0未完成存储，1完成存储
	uint32_t xmodemNB;           //xmodemNB总计页数
}OTA_flag;

typedef struct _OTA_MESSAGE_INFO{
	uint32_t Completion_flag;				 //用于记录ota事件是否完成,bootloader取出判断        
	uint32_t XmodemByte;                      //用于记录ota事件总计多少字节
}OTA_MESSAGE;

extern OTA_T ota_data;

int8_t check_ota_event();
#endif
