#include "gd32f10x.h"
#include "delay.h"

/*-------------------------------------------------*/
/*ʱʼ                               */
/*                                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void Delay_Init(void)
{
	systick_clksource_set(SYSTICK_CLKSOURCE_HCLK);    //Systickʱ
}
/*-------------------------------------------------*/
/*ʱ΢                                 */
/*  usʱ΢                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void Delay_Us(uint16_t us)
{
	SysTick->LOAD = us*108;                                //ֵ
	SysTick->VAL = 0x00;                                   //ǰֵ
	SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;              //Systick
	while(!(SysTick->CTRL&SysTick_CTRL_COUNTFLAG_Msk));    //ȵSystickLOADֵ0־λλʾʱʱ䵽
	SysTick->CTRL &=~ SysTick_CTRL_ENABLE_Msk;             //Systick
} 
/*-------------------------------------------------*/
/*ʱ                                 */
/*  usʱٺ                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void Delay_Ms(uint16_t ms)
{
	while(ms--){             //ѭ
		Delay_Us(1000);      //ÿʱ1000us
	}
}


