#include "ota_message.h"
#include "gd32f10x.h"
#include "w25q32.h"
#include <stdio.h>
static OTA_MESSAGE ota_message = {0};
void clear_ota_message_config_block(void);
void write_ota_message_to_flash(uint32_t *data, int size){
	uint8_t *pdata = (uint8_t *)data;
	W25Q32_PageWrite(pdata,256*OTA_EVENT_BLOCK);//дڵڶĵһҳ
}

/*
 *  save_ota_message_config_params(OTA_MESSAGE *params)
 *  
 *  
 *  ֵ
 *  ãota¼Ϣ
 */
int save_ota_message_config_params(OTA_MESSAGE *params)
{
		if(params == NULL)
				return -1;
		memset(&ota_message, 0, sizeof(OTA_MESSAGE));	
		memcpy(&ota_message, params, sizeof(OTA_MESSAGE)); 
	  clear_ota_message_config_block();
		write_ota_message_to_flash((uint32_t *)&ota_message,sizeof(OTA_MESSAGE));
		return 0;
}



/*
 *  load_config_params(CONFIG_PARAMS *params)
 *  
 *  
 *  ֵota־ǷЧ 0Ч -1Ч
 *  ãw25q32мotaϢ
 */
int load_ota_message_config_params()
{
		memset(&ota_message, 0, sizeof(OTA_MESSAGE));//ԭ
		W25Q32_Read((uint8_t *)&ota_message, OTA_EVENT_BLOCK*64*1024, sizeof(OTA_MESSAGE)); //W25Q32жȡṹ
		uint32_t *ptr=(uint32_t *)&ota_message;           
		if(*ptr == 1U)
		{
			return 0;
		}
		else return -1;
}
OTA_MESSAGE *get_config_params()
{
		return &ota_message;
}
/*
 *  void clear_ota_message_config_block(void)
 *  
 *  
 *  ֵ
 *  ãblockڰota¼Ϣ
 */
void clear_ota_message_config_block(void)
{
	W25Q32_Erase64K(OTA_EVENT_BLOCK);//һĴС
}
